<template>
  <div class="app-container">
    <el-form
      v-show="showSearch"
      ref="queryRef"
      :inline="true"
      :model="queryParams"
      label-width="68px"
    >
      <el-form-item label="" prop="tenantId">
        <el-input
          v-model="queryParams.tenantId"
          clearable
          placeholder="请输入"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="告警名称" prop="alertName">
        <el-input
          v-model="queryParams.alertName"
          clearable
          placeholder="请输入告警名称"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="告警级别" prop="alertLevel">
        <el-input
          v-model="queryParams.alertLevel"
          clearable
          placeholder="请输入告警级别"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="产品ID" prop="productId">
        <el-input
          v-model="queryParams.productId"
          clearable
          placeholder="请输入产品ID"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="Search" type="primary" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alert:add']"
          icon="Plus"
          plain
          type="primary"
          @click="handleAdd"
          >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alert:edit']"
          :disabled="single"
          icon="Edit"
          plain
          type="success"
          @click="handleUpdate"
          >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alert:remove']"
          :disabled="multiple"
          icon="Delete"
          plain
          type="danger"
          @click="handleDelete"
          >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alert:export']"
          icon="Download"
          plain
          type="warning"
          @click="handleExport"
          >导出
        </el-button>
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="alertList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column align="center" type="selection" width="55" />
      <el-table-column align="center" label="告警ID" prop="alertId" />
      <el-table-column align="center" label="" prop="tenantId" />
      <el-table-column align="center" label="告警名称" prop="alertName" />
      <el-table-column align="center" label="告警级别" prop="alertLevel" />
      <el-table-column align="center" label="产品ID" prop="productId" />
      <el-table-column align="center" label="触发器" prop="triggers" />
      <el-table-column align="center" label="执行动作" prop="actions" />
      <el-table-column align="center" label="告警状态" prop="status" />
      <el-table-column align="center" label="备注" prop="remark" />
      <el-table-column
        align="center"
        class-name="small-padding fixed-width"
        label="操作"
      >
        <template #default="scope">
          <el-button
            v-hasPermi="['device:alert:edit']"
            icon="Edit"
            link
            type="primary"
            @click="handleUpdate(scope.row)"
            >修改
          </el-button>
          <el-button
            v-hasPermi="['device:alert:remove']"
            icon="Delete"
            link
            type="primary"
            @click="handleDelete(scope.row)"
            >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:limit="queryParams.pageSize"
      v-model:page="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改设备告警对话框 -->
    <el-dialog v-model="open" :title="title" append-to-body width="500px">
      <el-form ref="alertRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="" prop="tenantId">
          <el-input v-model="form.tenantId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="告警名称" prop="alertName">
          <el-input v-model="form.alertName" placeholder="请输入告警名称" />
        </el-form-item>
        <el-form-item label="告警级别" prop="alertLevel">
          <el-input v-model="form.alertLevel" placeholder="请输入告警级别" />
        </el-form-item>
        <el-form-item label="产品ID" prop="productId">
          <el-input v-model="form.productId" placeholder="请输入产品ID" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            v-model="form.remark"
            placeholder="请输入内容"
            type="textarea"
          />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script name="Alert" setup>
import {
  addAlert,
  delAlert,
  getAlert,
  listAlert,
  updateAlert,
} from "@/api/device/alert";

const { proxy } = getCurrentInstance();

const alertList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    tenantId: null,
    alertName: null,
    alertLevel: null,
    productId: null,
    triggers: null,
    actions: null,
    status: null,
  },
  rules: {
    alertName: [
      { required: true, message: "告警名称不能为空", trigger: "blur" },
    ],
    alertLevel: [
      { required: true, message: "告警级别不能为空", trigger: "blur" },
    ],
    productId: [{ required: true, message: "产品ID不能为空", trigger: "blur" }],
    triggers: [{ required: true, message: "触发器不能为空", trigger: "blur" }],
    actions: [{ required: true, message: "执行动作不能为空", trigger: "blur" }],
  },
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备告警列表 */
function getList() {
  loading.value = true;
  listAlert(queryParams.value).then((response) => {
    alertList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    alertId: null,
    tenantId: null,
    alertName: null,
    alertLevel: null,
    productId: null,
    triggers: null,
    actions: null,
    status: null,
    createBy: null,
    createTime: null,
    remark: null,
  };
  proxy.resetForm("alertRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.alertId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备告警";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _alertId = row.alertId || ids.value;
  getAlert(_alertId).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改设备告警";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["alertRef"].validate((valid) => {
    if (valid) {
      if (form.value.alertId != null) {
        updateAlert(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addAlert(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _alertIds = row.alertId || ids.value;
  proxy.$modal
    .confirm('是否确认删除设备告警编号为"' + _alertIds + '"的数据项？')
    .then(function () {
      return delAlert(_alertIds);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "device/alert/export",
    {
      ...queryParams.value,
    },
    `alert_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
